﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Pristani_na_Mesici
{
    public partial class Form1 : Form
    {
        Motor[] Motory = new Motor[3];
        string Adresa="";
        int CisloPristani;
        Modul Modul=new Modul();
        Plocha Plocha;
        Bitmap Lander = new Bitmap(Properties.Resources.lunar_lander, new Size(60, 60));
        public Form1()
        {
            InitializeComponent();
            DoubleBuffered = true;
        }

        public void PripojSeNaServer(string adresa)
        {
            this.Focus();
            var http = (HttpWebRequest)WebRequest.Create(adresa);
            var response = http.GetResponse();
            StreamReader STR = new StreamReader(response.GetResponseStream());
            string precteno = STR.ReadLine(); //zkontroluje, jestli je konec
            if (precteno == "Zdar!")
            {
                tmr.Stop();
                MessageBox.Show("Uspesne pristani!");
                StartHry();
            }
            else if (precteno == "Krach!")
            {
                tmr.Stop();
                MessageBox.Show("Oh! Pristal jsi spatne. Zkus to znovu");
                StartHry();
            }
            else
            {
                CisloPristani = int.Parse(precteno);

                string[] polohaModulu = STR.ReadLine().Replace('.', ',').Split(' '); //nahrazeni tecek za carky, aby jsme to mohli konvertovat
                string[] rychlostModulu = STR.ReadLine().Replace('.', ',').Split(' ');
                double palivo = double.Parse(STR.ReadLine().Replace('.',','));
                float nic = float.Parse(rychlostModulu[1]);
                Modul.Poloha = new PointF(pictureBox1.Height - float.Parse(polohaModulu[0])*pictureBox1.Width/200, pictureBox1.Height-1 - float.Parse(polohaModulu[1])*pictureBox1.Height/200);
                Modul.Rychlost = new PointF(float.Parse(rychlostModulu[0]), float.Parse(rychlostModulu[1]));
                Modul.Palivo = palivo; //hazelo mi to z nejakeho neznameho duvodu chybu, tak jsem to napsal tahle
                string[] polohaPlochy = STR.ReadLine().Split(' ');
                Plocha = new Plocha(float.Parse(polohaPlochy[0].Replace('.', ','))*3, float.Parse(polohaPlochy[1].Replace('.', ','))*3);
            }
        }

        private void pictureBox1_Paint(object sender, PaintEventArgs e)
        {
            Lander = new Bitmap(Properties.Resources.lunar_lander, new Size((int)(pictureBox1.Width/200*20), (int)(pictureBox1.Height / 200 * 20)));
            e.Graphics.DrawImage(Lander, new PointF(Modul.Poloha.X - Lander.Width / 2, Modul.Poloha.Y - Lander.Height / 2));
                e.Graphics.DrawLine(new Pen(Color.Black), new PointF(Plocha.PolohaL, pictureBox1.Height - 1), new PointF(Plocha.PolohaR, pictureBox1.Height - 1));
            //nachazi se zde -1, protoze kdyby to bylo presne na Height, tak by nic neslo vydet
        }

        private void tmr_Tick(object sender, EventArgs e)
        {
            string adresa = Adresa + "/stav?id=" + CisloPristani;
            if (Motory[0].Zmena)
            {
                adresa += "&nahoru=" + Motory[0].Stav;
                Motory[0].Zmena = false;
            }
            if (Motory[1].Zmena) //zkontroluje, jestli byla nejaka zmena ve stavu, pokud je, tak ji "prida" k adrese
            {
                adresa += "&doleva=" + Motory[1].Stav;
                Motory[1].Zmena = false;
            }
            if (Motory[2].Zmena)
            {
                adresa += "&doprava=" + Motory[2].Stav;
                Motory[2].Zmena = false;
            }
            PripojSeNaServer(adresa);
            pictureBox1.Invalidate();
            Invalidate();
            ZobrazData();
        }

        private void Form1_KeyDown(object sender, KeyEventArgs e) //zapnuti motoru
        {
            switch (e.KeyData)
            {
                case Keys.Up:
                    ZapnoutMotor(0);
                    break;
                case Keys.Right:
                    ZapnoutMotor(1);
                    break;
                case Keys.Left:
                    ZapnoutMotor(2);
                    break;
            }
        }

        private void Form1_KeyUp(object sender, KeyEventArgs e) //pri zvednuti klavesy vypne motor
        {
            switch (e.KeyData) 
            {
                case Keys.Up:
                    VypnoutMotor(0);
                    break;
                case Keys.Right:
                    VypnoutMotor(1);
                    break;
                case Keys.Left:
                    VypnoutMotor(2);
                    break;
            }
        }

        private void Form1_Paint(object sender, PaintEventArgs e) //slouzi k vykreslovani paliva
        {
            e.Graphics.FillRectangle(new SolidBrush(Color.Red), new Rectangle(new Point(lblpalivo.Location.X+lblpalivo.Size.Width,lblpalivo.Location.Y),new Size((int)(Modul.Palivo * 2),15)));
        }

        public void ZobrazData()
        {
            lblNahoru.Text = "Prostredni motor: " + Motory[0].Stav; //na graficke casti zobrazovani dat jsem stravil hodne casu
            lblVlevo.Text = "Levy motor: " + Motory[1].Stav; //mym cilem bylo udelat zobrazovani co nejvic retro a na pohled jednoduche
            lblVravo.Text = "Pravy motor: " + Motory[2].Stav; //aby to co nejvic pripominalo mesicny lander
            lblRychlosti.Text = "X=" + Modul.Rychlost.X + " Y=" + Modul.Rychlost.Y;
        }

        public void StartHry()
        {
            string vlozeno;
            while (true)
            {
                vlozeno = Microsoft.VisualBasic.Interaction.InputBox("Zadejte adresu serveru", "Adresa", "http://localhost:8000", -1, -1);
                //Zobrazeni messegeboxu pro zadani adresy
                if (vlozeno != "")
                {
                    break;
                }
            }
            Adresa = vlozeno;
            PripojSeNaServer(Adresa + "/start");
            for (int i = 0; i < 3; i++)
            {
                Motory[i] = new Motor();
            }
            tmr.Start();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            StartHry();
        }

        
        private void pictureBox1_MouseMove(object sender, MouseEventArgs e) //pohyb pomoci mysi, kliknete na stranu, kde se ma zapnout motor
        {

            if (e.Button==MouseButtons.Left)
            {
                VypnoutVsechnyMotory();
                if (e.X < Modul.Poloha.X - Lander.Width / 2)
                {
                    ZapnoutMotor(1);
                }
                else if (e.X >= Modul.Poloha.X - Lander.Width / 2 & e.X <= Modul.Poloha.X + Lander.Width / 2)
                {
                    ZapnoutMotor(0);
                }
                else if (e.X > Modul.Poloha.X + Lander.Width / 2)
                {
                    ZapnoutMotor(2);
                }
            }
        }

        public void VypnoutVsechnyMotory()
        {
            for (int i = 0; i < 3; i++)
            {
                if (Motory[i].Stav == 1)
                {
                    Motory[i].Stav = 0;
                    Motory[i].Zmena = true;
                }
            }
        }

        public void ZapnoutMotor(int id)
        {
            if (Motory[id].Stav != 1)
            {
                Motory[id].Stav = 1;
                Motory[id].Zmena = true;
            }
        }

        public void VypnoutMotor(int id)
        {
            if (Motory[id].Stav != 0)
            {
                Motory[id].Stav = 0;
                Motory[id].Zmena = true;
            }
        }

        private void pictureBox1_MouseUp(object sender, MouseEventArgs e) //vypnuti motoru
        {
            if (e.X < Modul.Poloha.X - Lander.Width / 2)
            {
                VypnoutMotor(1);
            }
            else if (e.X >= Modul.Poloha.X - Lander.Width / 2 & e.X <= Modul.Poloha.X + Lander.Width / 2)
            {
                VypnoutMotor(0);
            }
            else if (e.X > Modul.Poloha.X + Lander.Width / 2)
            {
                VypnoutMotor(2);
            }
        }
    }
}
